var lista_pedidos;
class TablaPedidos extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      lista_pedidos : [],
      hash : "",
      estado : 0,
      id_empleado : 0
    }
    this.obtener = this.obtener.bind(this)
    this.cambiarFiltroEstado = this.cambiarFiltroEstado.bind(this)
    this.cambiarFiltroEmpleado = this.cambiarFiltroEmpleado.bind(this)

    this.obtener()


  }
  cambiarFiltroEstado(nuevo_e){
    this.setState({estado : nuevo_e})
  }
  cambiarFiltroEmpleado(){
    this.setState({id_empleado : $("#id_empleado").val()})
  }
  obtener() {
    var comp = this;
    $.ajax({
        type:"POST",
        url:"https://www.tfg.carlosh.es/admin/api/obtener_pedidos.php",
        data : {
          hash : comp.state.hash,
          id_empleado : comp.state.id_empleado
        },
        success:function(datos){
             lista_pedidos = datos.array;
             if(datos.hash != comp.state.hash){
               comp.setState({lista_pedidos: datos.array});
               comp.setState({hash: datos.hash});

             }
             setTimeout(comp.obtener, 1500);
         },
         error:function(datos){
           setTimeout(comp.obtener, 1500);
          },
         dataType : "json"
    })
  }



  render() {
    let listaAux = [];
    let arrayNumeroPedidos = [0,0,0,0,0,0];

    for(var i=0; i < this.state.lista_pedidos.length; i++){
      var est = this.state.lista_pedidos[i].estado == -1 ? 5 : this.state.lista_pedidos[i].estado;
        arrayNumeroPedidos[est]++;
        arrayNumeroPedidos[0]++;

        if( this.state.lista_pedidos[i].estado != 1 && this.state.lista_pedidos[i].id_producto < 0) continue;
        if(this.state.estado == 0) listaAux.push(this.state.lista_pedidos[i])
        if(this.state.lista_pedidos[i].estado == this.state.estado)
          listaAux.push(this.state.lista_pedidos[i])

    }
    const listPedidos = listaAux.map((mesa) =>
      <Pedido info={mesa} padre= {this}/>
    );
    const listEmpleados = empleados.map((empleado) =>
      <option value={empleado.id}>{empleado.nombre}</option>
    )

    var estado_aux = this.state.estado ==-1 ? 5 : this.state.estado;
    var clases = [];
    for(var i =0 ; i< 6 ; i++){
      clases[i] = "btn ";

      if(i == estado_aux) clases[i] += "btn-primary";
      else clases[i] += "btn-light";
    }


    return <div className="text-center">

              <div className="btn-group-sm" style={{width: "100%"}}>
                <button class={clases[0]} onClick ={(e) => this.cambiarFiltroEstado(0)}>Todos <span class="badge badge-light">{arrayNumeroPedidos[0]}</span></button>
                <button class={clases[1]} onClick ={(e) => this.cambiarFiltroEstado(1)}>En espera <span class="badge badge-light">{arrayNumeroPedidos[1]}</span></button>
                <button class={clases[2]} onClick ={(e) => this.cambiarFiltroEstado(2)}>Cocina <span class="badge badge-light">{arrayNumeroPedidos[2]}</span></button>
                <button class={clases[3]} onClick ={(e) => this.cambiarFiltroEstado(3)}>Para entregar <span class="badge badge-light">{arrayNumeroPedidos[3]}</span></button>
                <button class={clases[4]} onClick ={(e) => this.cambiarFiltroEstado(4)}>Entregados <span class="badge badge-light">{arrayNumeroPedidos[4]}</span></button>
                <button class={clases[5]} onClick ={(e) => this.cambiarFiltroEstado(-1)}>Cancelados <span class="badge badge-light">{arrayNumeroPedidos[5]}</span></button>
              </div>
              Empleado:
              <select id="id_empleado" className="form-control" onChange ={(e) => this.cambiarFiltroEmpleado()}>
              <option value="0">Todos</option>
              {listEmpleados}
              </select>

              <div style={{width: "100%"}} >

              {listPedidos}
              </div>
            </div>
  }
}

class Pedido extends React.Component {
  constructor(props) {
    super(props)
  }

  render() {

    let estado;
    let clase_estado;
    let producto;
    let extras;
    let boton;
    let fila;
    let tiempo = parseInt(this.props.info.diff_horas) > 0 ? "+ 1h" : this.props.info.diff_minutos +"m";
    let sesion_href = "sesion.php?id_sesion=" + this.props.info.id_sesion;
    switch(this.props.info.estado){
      case "1": estado = "Pedido en espera"; clase_estado = "badge badge-light";break;
      case "2": estado = "En preparación"; clase_estado = "badge badge-info"; break;
      case "3": estado = "Preparado"; clase_estado = "badge badge-success"; break;
      case "4": estado = "Entregado"; clase_estado = "badge badge-dark"; break;
      case "-1": estado = "Cancelado"; clase_estado = "badge badge-danger"; break;

    }

    if(this.props.info.id_producto <0){
      //PEDIDO
      switch (this.props.info.id_producto) {
        case "-1": producto = "Solicitud de camarero"; break;
        case "-2": producto = "Pago en efectivo"; break;
        case "-3": producto = "Pago con tarjeta"; break;

      }
      boton = <div>
                 <button type="button" className="btn btn-info " onClick ={(e) => cambiarEstado(this.props.info.id, 4)}>
                  Marcar como realizada
                 </button>
                 <button type="button" style={{marginLeft:"5px"}} className="btn btn-danger " onClick ={(e) => cambiarEstado(this.props.info.id, -1)}>
                  Cancelar
                 </button>
                </div>

      fila = <div className="card wow zoomIn" style={{cursor:"pointer"}} >
              <div className="row" style={{padding:"10px"}}>
              <div className="col-6 text-left">{this.props.info.nombre_mesa} - {this.props.info.codigo_mesa}</div>
              <div className="col-6 text-right"><span className={clase_estado} >{estado} </span> </div>
              <div className="col-12 text-left">
                <h3>{producto} <span style={{fontSize:"15px"}}> Hace {tiempo}</span></h3>
              </div>
              <div className="col-12 text-right">
                {boton}
              </div>
              </div>
            </div>

    }else{
      //// PRODUCTO

        extras = ""
        producto = this.props.info.producto;
        var lista_extras = this.props.info.extras;
        console.log("" +this.props.info.extras)
        if(lista_extras){
          for(var i =0 ; i< lista_extras.length; i++){
            lista_extras[i].valores = lista_extras[i].nombre + ": ";
            if(lista_extras[i].listaValores){
              for(var j = 0; j < lista_extras[i].listaValores.length; j++){
                var valor = lista_extras[i].listaValores[j];
                var coma = j != 0 ? ", " : "";
                lista_extras[i].valores += coma + valor.nombre ;
              }
            }

          }
        }
        extras = lista_extras.map((extra) =><div>
        <span className="badge badge-primary">{extra.valores} </span>
                      </div>
      )




      boton =    <button type="button" className="btn btn-light " onClick ={(e) => acciones(this.props.info.id, this.props.info.estado)}>
                  <span className="fa fa-ellipsis-v	"></span>
                 </button>


      fila = <div className="card wow zoomIn" style={{cursor:"pointer"}} onClick ={(e) => acciones(this.props.info.id, this.props.info.estado)}>
              <div className="row" style={{padding:"10px"}}>
                <div className="col-6 text-left">{this.props.info.nombre_mesa} - {this.props.info.codigo_mesa}</div>
                <div className="col-6 text-right"><span className={clase_estado} >{estado} </span> </div>
                <div className="col-12 text-left">
                  <h3>{producto} <span style={{fontSize:"15px"}}> Hace {tiempo}</span></h3>
                </div>
                <div className="col-12 text-left" style={{paddingLeft:"100px"}}>
                  Notas: {this.props.info.notas}
                </div>
                <hr />
                <div className="col-12 text-left" style={{paddingLeft:"100px"}}>
                  Extras: {extras}
                </div>
                <div className="col-12 text-center" style={{paddingLeft:"100px"}}>
                  <a href={sesion_href} className="btn btn-secondary" >Mesa</a>
                </div>
              </div>
      </div>


    }



    return <div> {fila} </div>
  }
}
ReactDOM.render(<TablaPedidos />, document.getElementById('tabla'));






function acciones(id_producto,estado){
  console.log("EEY")
  var btn_cancelar = ' <button class= "btn btn-danger" onclick="cambiarEstado('+ id_producto+' , -1)"  style="width:80%;height:100px;">Cancelar</button> <br> ';;
  var btn_espera= ' <button class= "btn btn-light" onclick="cambiarEstado('+ id_producto+' , 1)"  style="width:80%;height:100px;">Marcar en espera</button> <br> ';;
  var btn_preparar = ' <button class="btn btn-info"  onclick="cambiarEstado('+ id_producto+' , 2)" style="width:80%;height:100px;">Oido cocina</button><br>';
  var btn_preparado = '<button class="btn btn-success"  onclick="cambiarEstado('+ id_producto+' , 3) " style="width:80%;height:100px;">Marcar como preparada</button> <br>' ;
  var btn_entregado = '<button class="btn btn-dark" onclick="cambiarEstado('+ id_producto+' , 4) " style="width:80%;height:100px;">Marcar entregado</button> <br>';
  var botones;
  switch(estado){
    case '-1':
      botones = btn_espera;
      break;
    case '1':
      botones = btn_preparar + btn_cancelar;
      break;
    case '2':
      botones =  btn_preparado ;
      break;
    case '3':
      botones =  btn_entregado;
      break;
    case '4':
      botones = btn_espera;
      break;

  }
  $.confirm({
      title: "Editor pedido ",
      content: ' \
        <div class="text-center"> \
          '+botones+' \
        </div> \
      ',
      columnClass: 'large',
      buttons: {

          Cancelar: function () {
          }
      }
      });
}



function cambiarEstado(id_pedido2,nuevo_estado){
  console.log("CAMBIOOO")
                  $.ajax({
                      type:"POST",
                      url:"https://www.tfg.carlosh.es/admin/api/editar_estado_pedido.php",
                      data:{
                            id_pedido: id_pedido2 ,
                            estado: nuevo_estado
                          },
                      success:function(datos){
                        $(".jconfirm")[0].remove();
                       },
                  })

}
