

$.ajax({
    type:"POST",
    url:"https://www.tfg.carlosh.es/app/api/obtenerCarta.php",
    success:function(datos){
        lista_categorias = datos.array;
        ReactDOM.render(<Carta />, document.getElementById('main'));

     },
     dataType : "json"
})


function ajaxObtenerPedidos(){

  $.ajax({
      type:"POST",
      url:"https://www.tfg.carlosh.es/app/api/obtenerPedidos.php",
      success:function(datos){
          if(datos.hash != hash){
            pedidosRealizados = datos.array;
            hash = datos.hash;
            rellenarModalPedidos(tipo_pedidos_menu);
          }
          comprobarFin()
          setTimeout(ajaxObtenerPedidos, 1500);
       },
       dataType : "json"
  })
}
ajaxObtenerPedidos()

class Carta extends React.Component {
  constructor(props) {
    super(props)


  }
  render() {
    const listaCategorias = lista_categorias.map((cat) =>
      <Categoria  info={cat}/>
    );
    const estiloBoton = {
      margin:"15px",
      padding:"10px",
      fontSize:"25px"
    };
    let btn_cuenta= <button className="btn btn-light wow zoomIn" style={estiloBoton} style={estiloBoton} onClick= {(e) => solicitarCuenta()}>
                      <i className="fa fa-edit"></i> <br/>
                      Solicitar la cuenta
                    </button>
    let btn_camarero= <button className="btn btn-light wow zoomIn" style={estiloBoton} onClick= {(e) => solicitarCamarero()}>
                        <i className="fa fa-user	"></i> <br/>
                        Solicitar Camarero
                      </button>

    return <div class="carta">
              {btn_camarero}
              {btn_cuenta}
            <div className="row">
            {listaCategorias}
            </div>
           </div>
    }
  }



  class Categoria extends React.Component {
    constructor(props) {
      super(props)


    }
    render() {
      let listaProd = lista_categorias[this.props.info.indice].productos;
      const listaProductos = listaProd.map((prod) =>
      <Producto indice_categoria={this.props.info.indice} info={prod} />
      );
      return  <div className="col-sm-6 col-12">
                <details class="categoria" style={{marginTop:"5px"}}>
                  <summary className="wow zoomIn" style={{ backgroundColor:"#11111133", width:"95%", margin :"0 auto", borderRadius:"5px"}}>
                    <h1>{this.props.info.nombre}</h1>
                  </summary>
                  <div className=" container">
                    <div className="row">
                    {listaProductos}
                    </div>
                  </div>
                </details>
              </div>

      }
  }


  class Producto extends React.Component {
    constructor(props) {
      super(props)
    }
    render() {
      const estiloProducto = {
        fontSize:"20px",
        marginTop : "10px",
        minHeight: "100px",
        padding: "0px"
      };


      return <div className="col-6">
                <div style={estiloProducto} className="producto card shadow " onClick ={(e) => informacionProducto(this.props.info)}>
                <img style={{"width": "100%"}}className="card-img-top" src={this.props.info.img} alt="Card image cap" />
                <div className="card-body">
                  <p className="card-text">{this.props.info.nombre}</p>
                  {this.props.info.precio} € <br/>
                </div>
              </div>
            </div>

      }
  }






  class MiPerfil extends React.Component {
    constructor(props) {
      super(props)


    }
    render() {
      const estiloDiv = {
        backgroundColor: 'white',
        width: '90%',
        margin :"0 auto",
        textAlign: "left",
        padding:"5px",
        fontSize:"20px",
        marginTop : "10px",
        minHeight: "100px",
        textAlign:"center",
        fontSize:"30px"
      };
      var p_pendientes = 0, p_entregados = 0, p_cancelados = 0;
      for(var i = 0; i< pedidosRealizados.length; i++){
        if(pedidosRealizados[i].id_producto < 0) continue;
        if(pedidosRealizados[i].estado == -1) p_cancelados++;
        else if(pedidosRealizados[i].estado == 4) p_entregados++;
        else p_pendientes++;
      }
      return <div style={estiloDiv} class="mi-perfil">

      <a    onClick ={(e) => mostrarCuenta()} href="#">
        <div className="wow zoomIn card"  style={estiloDiv}>
        Mi cuenta
        </div>
      </a>
      <a    onClick ={(e) => mostraPedido(1)} href="#">
        <div className="wow zoomIn card"  style={estiloDiv}>Pedidos pendientes {p_pendientes}</div>
      </a>
      <a    onClick ={(e) => mostraPedido(4)} href="#">
        <div className="wow zoomIn card"  style={estiloDiv}>Pedidos entregados {p_entregados}</div>
      </a>
      <a    onClick ={(e) => mostraPedido(-1)} href="#">
        <div className="wow zoomIn card"  style={estiloDiv}>Pedidos cancelados {p_cancelados}</div>
      </a>
      <a  href="cerrarSesion.php">
        <div  className="wow zoomIn card"  style={estiloDiv}>Cerrar sesión</div>
      </a>

      </div>
      }
    }


class Pedido extends React.Component {
  constructor(props) {
    super(props)
      this.state= {
        extras : productoActual.extras,
        indiceActual : 0
    }
  }

  siguienteExtra(){
    let indice_aux = this.state.indiceActual +1;
    let objAux = {};
    objAux.id = this.state.extras[indice_aux-1].id;
    objAux.listaValores = [];
    $(".opcion-pedido").each(function(x,y){
      if(y.checked){
        var precioCalculado = y.getAttribute("inc_dec") ==0  ? y.getAttribute("precio") : y.getAttribute("precio") * -1;
        objAux.listaValores.push({id:y.value,
                                  nombre: y.getAttribute("nombre") ,
                                  precio : precioCalculado
                                });
      }
    })
    pedidoActual.extras.push(objAux);
    this.setState({indiceActual: indice_aux});
  }
  anteriorExtra(){
    let indice_aux = this.state.indiceActual -1;
    for(var i =0 ; i< pedidoActual.extras.length ; i++){
      if(pedidoActual.extras[i].id == this.state.extras[indice_aux].id )
      pedidoActual.extras.splice(i, 1);
    }

    this.setState({indiceActual: indice_aux});
  }

  render() {
    const estiloBtnRealizar = {
      width:"100%",
      marginTop:"10px",
      padding:"20px",
      fontSize:"40px",
      whiteSpace: "normal"
    }
    const estiloBtnMasTarde = {
      width:"60%",
      marginTop:"10px",
      padding:"10px",
      fontSize:"20px",
      whiteSpace: "normal"

    }
    const estiloBtnSiguiente = {
      width:"80%",
      marginTop:"10px",
      padding:"20px",
      fontSize:"40px",
      whiteSpace: "normal"
    }
    const estiloBtnAtras = {
      width:"60%",
      marginTop:"10px",
      padding:"10px",
      fontSize:"20px",
      whiteSpace: "normal"
    }
    const estiloOpciones = {
      marginTop:"10px",
      padding:"10px",
      fontSize:"30px"
    }
    const estiloCheck = {
      marginRight:"10px",
      width : "20px",
      height : "20px"
    }



    let final ;
    let btnAtras = "";
    if(!this.state.extras[this.state.indiceActual]){
      //ULTIMO PASO
      if(this.state.extras.length > 0) btnAtras = <input type="button" className="btn btn-light" style={estiloBtnAtras} value="Atrás" onClick ={(e) => this.anteriorExtra()}/>
      var precioTotal = parseFloat(productoActual.precio);
      var extrasSeleccionados = [];
      for(var i = 0; i<pedidoActual.extras.length ; i++){
        for(var j = 0; j<pedidoActual.extras[i].listaValores.length; j++){
          var valor = pedidoActual.extras[i].listaValores[j];
          extrasSeleccionados.push(valor)
          precioTotal += parseFloat(valor.precio);
        }
      }

      let resumenExtras = extrasSeleccionados.map((valor) =>
            <div style={{fontSize: "22px"}}>{valor.nombre}  {valor.precio}€</div>
      );
      const ultimoPaso = <div>
        <div style={{fontSize:"30px"}}>
          <div className="text-right">
            {resumenExtras}
            Precio total: {precioTotal} €
          </div>
        </div>
        <div className="text-left">Notas:</div>
          <textArea id="notas_pedido" type="text" className="form-control"  style={{fontSize:'25px'}} placeholder="Si quieres dar más información del pedido escríbelo aquí"></textArea>
          <input type="button" value="Realizar pedido" className="btn btn-success" style={estiloBtnRealizar} onClick={(e) => realizarPedido()} />
          {btnAtras}
        </div>
      final = ultimoPaso;
      //  <input type="button" value="Guardar para pedir más tarde" className="btn btn-dark" style={estiloBtnMasTarde} />

    }else{
      //HAY ALGUN EXTRA PENDIENTE
      var a = this.state.extras[this.state.indiceActual];
      let titulo = <h1>{a.nombre} </h1>
      let listaOpciones;
      let tipo = a.multiple == 1 ? "checkbox" : "radio"
      listaOpciones = a.opciones.map((opcion) =>
        <div style={estiloOpciones}>
        <input className="opcion-pedido" style={estiloCheck} type={tipo} name={a.nombre} nombre={opcion.nombre} value={opcion.id} precio={opcion.precio} inc_dec={opcion.inc_dec}/>
        <span  >{opcion.nombre} <span>{opcion.inc_dec == 0 ? "+" : "-"}{opcion.precio}€</span></span>
        </div>
      );
    btnAtras = "";
    if(this.state.indiceActual > 0) btnAtras = <input type="button" className="btn btn-light" style={estiloBtnAtras} value="Atrás" onClick ={(e) => this.anteriorExtra()}/>
    const menuExtra = <div>
                  {titulo}
                  <div className="container text-left" style={{maxHeight:"300px",overflowY:"scroll"}}>{listaOpciones}</div>
                  <input type="button" className="btn btn-light" style={estiloBtnSiguiente} value="Siguiente" onClick ={(e) => this.siguienteExtra()}/>
                  {btnAtras}
                  </div>

      final = menuExtra;

    }
    return <div>{final} </div>
    }
}


/***     FUNCIONES     **///


  function abrirCarta(){
    ReactDOM.render(<Carta />, document.getElementById('main'));

  }
  function abrirMiPerfil(){
    ReactDOM.render(<MiPerfil />, document.getElementById('main'));

  }

  function solicitarCamarero(){

    $.confirm({
        title: "Solicitar camarero",
        content: '\
                  <input type="button" value="Solicitar camarero" class="btn btn-success" onclick="ajax_peticion_especial('+ 1 +')" style="width:100%;margin-top:10px;padding:20px;font-size:40px" />'
        ,buttons :{
              Cancelar: {
                text: "Cancelar",
                action: function () {
                }
              }
        },
        columnClass: 'large'
      })
  }
  function solicitarCuenta(){
    var precioTotal = 0;
    var desglosePrecios = obtenerDesglosePrecios()
    $.confirm({
        title: "Solicitar cuenta",
        content: desglosePrecios + '\
                  <button class="btn btn-dark" style="width:100%;margin-top:10px;padding:20px;font-size:40px" onclick="ajax_peticion_especial('+ 2 +')"  > \
                    Efectivo \
                  </button> \
                  <button class="btn btn-info" style="width:100%;margin-top:10px;padding:20px;font-size:40px" onclick="ajax_peticion_especial('+ 3 +')" > \
                    Tarjeta \
                  </button>'
        ,buttons :{
          Cancelar: {
                text: "Cancelar",
                action: function () {
                }
              }
        },
        columnClass: 'large'
      })
  }
  function ajax_peticion_especial(opcion,notas){
    $.ajax({
        type:"POST",
        data :{
          opcion : opcion *-1
        },
        url:"https://www.tfg.carlosh.es/app/api/peticion_especial.php",
        success:function(datos){
            $(".jconfirm").remove()
            if(datos.error){
              alertError(datos.error)
            }

         },
         dataType : "json"
    })
  }

function informacionProducto(producto){
  if(pedidoActual.id != undefined) return;
  productoActual = producto;
  pedidoActual.id = productoActual.id;
  pedidoActual.extras = [];
  var ingredientes = producto.ingredientes == "" ? "" :  '<b>Ingredientes</b>: '+ producto.ingredientes

  $.confirm({
      title: producto.nombre +"<br>"+ producto.precio + "€" ,
      content: '\
              <img src="'+ producto.img+'" style="height:200px"> <br> \
              <div class="container" style="font-size:25px;"> \
                '+producto.descripcion+'<br> \
                '+ ingredientes+' <br>\
                <input type="button" value="Pedir" class="btn btn-success" style="width:100%;margin-top:10px;padding:20px;font-size:40px;" onclick="pedir()"> \
              </div> '
      ,buttons :{
            Cancelar: {
              text: "Cancelar",
              action: function () {
                pedidoActual = {}
              }
            }
      },
      columnClass: 'large'
    })
}

var cancelar_pedido = false;
function pedir(){
  progreso_pedido = 0;
  cancelar_pedido = false;
  $("#progreso-pedido").css("width", progreso_pedido +"%");
  $("#alerta-producto-actual").html('\
  <img src="'+productoActual.img+'" style="height:75px;" > <br> \
    '+productoActual.nombre +'\
  ')
  $.confirm({
      title: "Pedido de " + productoActual.nombre + "  " +productoActual.precio + "€" ,
      content: '<div id="extras-pedido"></div>'
      ,buttons :{
            Cancelar: {
              text: "Cancelar",
              action: function () {
              }
            }
      },onContentReady: function(data, status, xhr){
        ReactDOM.render(<Pedido />, document.getElementById('extras-pedido'));
      },
      columnClass: 'large'
    })

}

/* AJAX */
function realizarPedido(){
  if(progreso_pedido ==0)pedidoActual.notas = $("#notas_pedido").val()
  if(cancelar_pedido){
    $("#alert-cancelar-pedido").hide();
    pedidoActual  ={}

    return
  }
  if(progreso_pedido < 101){

    $("#alert-cancelar-pedido").show();
    $("#progreso-pedido").css("width", progreso_pedido +"%");
    progreso_pedido += 10;
    setTimeout(realizarPedido, 250);

  }else{
    for(var i = 0; i< pedidoActual.length; i++){
      for(var j= 0; j< pedidoActual[i].listaValores.length; j++){
        pedidoActual[i].listaValores[j].nombre = undefined;
      }
    }
    var pedido_json = JSON.stringify(pedidoActual);
    $.ajax({
        type:"POST",
        data :{
          pedido : pedido_json
        },
        url:"https://www.tfg.carlosh.es/app/api/realizarPedido.php",
        success:function(datos){
            $(".jconfirm").remove()
            if(datos.error){
              alertError(datos.error)
            }

         },
         dataType : "json"
    })

    pedidoActual  ={}
    $("#alert-cancelar-pedido").hide();
  }
  $(".jconfirm").remove()
}


function mostraPedido(n){
  tipo_pedidos_menu = n
  var tipo_pedidos= "";
  switch (n) {
    case 1:
      tipo_pedidos = "pendientes"
      break;
    case 4:
      tipo_pedidos = "entregados"
      break;
    case -1:
      tipo_pedidos = "cancelados"
      break;

  }
  $.confirm({
      title: "<h1>Pedidos " + tipo_pedidos+ "</h1>",
      content: '<div id="contenido_modal_pedidos" style=" overflow-x: hidden;"></div>',
      buttons :{
            Cancelar: {
              text: "Cancelar",
              action: function () {
              }
            }
      },onContentReady: function(data, status, xhr){
        rellenarModalPedidos(tipo_pedidos_menu);
      },
      columnClass: 'large'
    })
}

function mostrarCuenta(){
  var desglosePrecios = obtenerDesglosePrecios()
  $.confirm({
      title: "Cuenta",
      content: desglosePrecios
      ,buttons :{
        Cancelar: {
              text: "atras",
              action: function () {
              }
            }
      },
      columnClass: 'large'
    })
}

function rellenarModalPedidos(n){
  var contenido = "";
  var estado = "";
  var barra__progreso = ""
  var btn_cancelar  ="";
  var vacia = true;
  var lista_aux = [];
  for(var i = 0; i< pedidosRealizados.length; i++){
    if(pedidosRealizados[i].id_producto <0) continue;
    if(n == 1 && ( pedidosRealizados[i].estado == 1 || pedidosRealizados[i].estado == 2 || pedidosRealizados[i].estado == 3  )) lista_aux.push(pedidosRealizados[i])
    else if(pedidosRealizados[i].estado == n ) lista_aux.push(pedidosRealizados[i])

  }

  for(var i = 0; i< lista_aux.length; i++){

    vacia = false;
    switch(lista_aux[i].estado){
      case "1":
        barra__progreso ='<div class="progress" style="height:20px;margin-top:10px;">\
              <div  class="progress-bar bg-secondary" style="width:30%" > En espera</div> \
            </div> '
        btn_cancelar = '<br><input type="button" onclick="cancelarPedido('+lista_aux[i].id+')" class="btn btn-danger" value="Cancelar" style="width:80%; margin: 0 auto; margin-top:5px;">'
        break;
      case "2":
      barra__progreso ='<div class="progress" style="height:20px;margin-top:10px;">\
            <div  class="progress-bar" style="width:60%" > En preparación</div> \
          </div> '

        break;
      case "3":
      barra__progreso ='<div class="progress" style="height:20px;margin-top:10px;">\
            <div  class="progress-bar bg-success" style="width:80%" >Pendiente de ser entregado</div> \
          </div> '
        break;
    }
    contenido +=' <div class="card" style="margin-bottom:5px;padding:10px;max-height:350px;"> \
                  <div class=" row" >\
                  <div class="col-4"><img src="/img/productos/'+lista_aux[i].img+' " style="width:150px;"></div> \
                  <div class="col-8">'+lista_aux[i].producto+'</div> \
                  <div class="col-12">'+barra__progreso+'</div> \
                  '+btn_cancelar + ' \
                </div></div>\
    ';
  }
  if(vacia) contenido ="<div style='font-size:30px;'>Sin pedidos</div>"
  $("#contenido_modal_pedidos").html(contenido);


}

function cancelarPedido(id_pedido){
  $.confirm({
      title: '¿Seguro que quieres cancelar este pedido?',
      content: '',
      type: 'red',
      typeAnimated: true,
      buttons: {
          Cancelar: {
              text: 'Cancelar pedido',
              btnClass: 'btn-red',
              action: function(){
                $.ajax({
                    type:"POST",
                    data :{
                      id_pedido : id_pedido
                    },
                    url:"https://www.tfg.carlosh.es/app/api/cancelarPedido.php",
                    success:function(datos){

                     } //,
                     //dataType : "json"
                })
              }
          },
          atras: function () {
          }
      }
  });

}

function comprobarFin(){
  var fin = false;
  for(var i =0 ; i< pedidosRealizados.length; i++){
    if(pedidosRealizados[i].estado != -1 && pedidosRealizados[i].id_producto<-1){
      fin = true;
      var desglosePrecios = obtenerDesglosePrecios()
      if(pedidosRealizados[i].estado == 4){
        $("#cuenta-final").html(desglosePrecios);
        $("#modal-pagado").modal("show")
        $("#modal-pendiente").modal("hide")

      }else{
        $("#cuenta-final-2").html(desglosePrecios);
        $("#modal-pendiente").modal("show")

        $("#modal-pagado").modal("hide")
      }
    }
  }
  if(!fin) $("#modal").modal("hide")

}

function alertError(texto){
  $.confirm({
      title: texto,
      content: '',
      type: 'red',
      typeAnimated: true,
      buttons: {

          atras: function () {
          }
      }
  });
}

function cancelarCuenta(){
  $.ajax({
      type:"POST",
      url:"https://www.tfg.carlosh.es/app/api/cancelarCuenta.php",
      success:function(datos){

       } //,
       //dataType : "json"
  });
  $("#modal-pendiente").modal("hide");
}

function obtenerDesglosePrecios(){
  var precioTotal = 0;
  var desglosePrecios = '<div class="text-right" style="font-size:25px;">'
  for(var i = 0; i<pedidosRealizados.length; i++){
    if(pedidosRealizados[i].id_producto <0) continue;
    if(pedidosRealizados[i].estado <0) continue;

    var precioParcial = parseFloat(pedidosRealizados[i].precio);
    var pedido_aux = '<div>'+pedidosRealizados[i].producto //+':'+ pedidosRealizados[i].precio +' €<p>';
    var listaExtras_aux = JSON.parse(pedidosRealizados[i].extras)
    for(var j = 0; j< listaExtras_aux.length; j++){
      var extra_aux = listaExtras_aux[j];
      if(extra_aux.listaValores.length > 0){
        for(var k = 0; k< extra_aux.listaValores.length; k++){
        //  pedido_aux += " , "+ extra_aux.listaValores[k].nombre
          precioParcial +=  parseFloat(extra_aux.listaValores[k].precio);

        }
      }
    }
    pedido_aux += "      " +precioParcial + " €</div>";
    precioTotal += parseFloat(precioParcial);
    desglosePrecios += pedido_aux;// '<p>'+pedidosRealizados[i].producto+':'+ pedidosRealizados[i].precio +' €<p>';
  }
  desglosePrecios += "<span style='font-size:30px;'><b>Total:</b>" + precioTotal + "€</span>";

  desglosePrecios += "</div>";
  return desglosePrecios;

}
