<?php
include "funciones/inicioSesion.php";
if($id_usuario <0){
    include "vistas/formularioInicio.php";
    die;
}
$error;

if(isset($_POST["add_usuario"])) {

  if($permisos_usuario  != 1){
    $error  = "NO tienes permisos";
  }else if($_POST["nombre"] != "" ){
    if(!existeRegistro("SELECT id FROM usuarios where nombre = '$_POST[nombre]'; ")){
      sqli("INSERT INTO usuarios (nombre,password,permisos) values('$_POST[nombre]',MD5('$_POST[password]'),$_POST[permisos]);");
    }
  }
}

if(isset($_GET["eliminar"])) {

  if($permisos_usuario  != 1){
    $error  = "NO tienes permisos";
  }else{
    if(!existeRegistro("SELECT id FROM usuarios where nombre = '$_POST[nombre]' AND permisos = 1; ")){
      sqli("DELETE FROM usuarios WHERE id = '$_GET[eliminar]'");
    }
  }
}

if(isset($_POST["old_pass"])) {

  if(!existeRegistro("SELECT id FROM usuarios WHERE password = MD5('$_POST[old_pass]')")){
    $error  = "NO tienes permisos";
  }else{
      if($_POST["new_pass"] != $_POST["confirm_pass"]){
        $error  = "Las contraseñas no coinciden";

      }else{
        sqli("UPDATE usuarios SET password = MD5('$_POST[new_pass]') WHERE id = $_POST[id];");
      }
  }
}

if(isset($_POST["nombre_editar"])) {

  if($id_usuario != $_POST[id]){
    $error  = "NO tienes permisos";
  }else{
    sqli("UPDATE usuarios SET nombre = '$_POST[nombre_editar]' WHERE id = $_POST[id];");
    $error  = "SELECT id FROM usuarios WHERE id = $_POST[id];";

  }
}

?>
<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <? include "vistas/head.php"; ?>
  </head>
  <body>

    <? include "vistas/jumbotron.php"; ?>
    <div class="container text-center main">
      <button type="button" class="btn btn-success" data-toggle="modal" data-target="#myModal" style="width:80%; height:100px;margin-bottom:50px;">Nuevo usuario</button>
      <?
      $consulta_usuarios = sqli("select * from usuarios;");
      while($us = mysqli_fetch_array($consulta_usuarios)){
        $tipo_empleado = $us["permisos"] == 1 ? "Administrador" : "Empleado";
        ?>
        <div class="card text-left" style="padding:10px;">
          <div class="text-right">
            <?
            if($id_usuario == $us["id"]){
            ?>
              <button class="btn btn-info" onclick="editar_password(<?= $us["id"] ?>,'<?= $us["nombre"] ?>')">Cambiar contraseña</button>
              <button class="btn btn-warning" onclick="editar_usuario(<?= $us["id"] ?>,'<?= $us["nombre"] ?>')"><i class="fa fa-pencil"></i></button>
            <? } ?>
            <button class="btn btn-danger" onclick="eliminar_usuario('<?= $us["id"] ?>','<?= $us["nombre"] ?>')">X</button>
          </div>
          <h3><?= $us["nombre"] ?> (<?= $tipo_empleado ?>)</h3>

        </div>
<?
      }

      ?>
    </div>

    <div class="modal fade" id="myModal">
      <div class="modal-dialog">
        <div class="modal-content">

          <!-- Modal Header -->
          <div class="modal-header">
            <h4 class="modal-title">Nuevo usuario</h4>
            <button type="button" class="close" data-dismiss="modal">X</button>
          </div>

          <!-- Modal body -->
          <div class="modal-body">

            <form class="" action="usuarios.php" method="post"  enctype="multipart/form-data">
              Nombre:
              <input type="text" name="nombre" class="form-control">
              Contraseña
              <input type="password" name="password" class="form-control">
              <select class="form-control" name="permisos">
                <option value="1">Administrador</option>
                <option value="2">Empleado</option>
              </select>

              <input type="submit" name="add_usuario" class="btn btn-success" value="Añadir">
            </form>

          </div>



        </div>
      </div>
    </div>


    <script type="text/javascript">
      function eliminar_usuario(id, nombre){
        if(confirm("Seguro que quieres eliminar el usuario "+  nombre)){
          location.href = "usuarios.php?eliminar="+id;

        }
      }

      function editar_password(id, nombre){
        $.confirm({
    title: 'Editar usuario',
    content: '' +
    '<form id="formulario_editar_password" action="usuarios.php" class="formName" method="post">' +
    '<div class="form-group">' +
    '<input type="text" name="id" value="'+id+'" class="form-control" required hidden/>' +
    'Antigua contraseña:<input type="password"  name="old_pass" class="form-control" required />' +
    'Nueva contraseña:<input type="password" name="new_pass" class="form-control" required />' +
    'Confirmar contraseña:<input type="password" name="confirm_pass" class="form-control" required />' +

    '</div>' +
    '</form>',
    buttons: {
        formSubmit: {
            text: 'Editar',
            btnClass: 'btn-blue',
            action: function () {
              $("#formulario_editar_password").submit();
            }
              },
              Cancelar: function () {
                  //close
              },
          }
      });
    }

      function editar_usuario(id, nombre){
      $.confirm({
      title: 'Editar usuario',
      content: '' +
      '<form id="formulario_editar_nombre" action="usuarios.php" class="formName" method="post">' +
      '<div class="form-group">' +
      '<input type="text" name="id" value="'+id+'" class="form-control" required hidden/>' +
      'Nombre: <br><input type="text"  value="'+nombre+'"name="nombre_editar" class="form-control" required />' +
      '</div>' +
      '</form>',
      buttons: {
          formSubmit: {
              text: 'Editar',
              btnClass: 'btn-blue',
              action: function () {
                $("#formulario_editar_nombre").submit();

              }
                },
                Cancelar: function () {
                    //close
                },
            }
        });
      }


    </script>


  </body>
</html>
